/// <reference types="terser-webpack-plugin" />
export interface ClientBase {
    legacy?: boolean;
    includedPackages?: string[] | RegExp[];
    manifestSharedSeed?: any;
}
export declare const createClientBaseConfig: (options: ClientBase) => {
    target: string;
    name: string;
    entry: {
        [x: string]: string[];
        main?: undefined;
    } | {
        main: string[];
    };
    plugins: any[];
    module: {
        rules: {
            test: RegExp;
            use: any;
        }[];
    };
    output: {
        filename: string;
        chunkFilename: string;
        path: string;
        publicPath: string;
    };
    context: string;
    mode: string;
    devtool: string | undefined;
    resolve: {
        alias: any;
        extensions: string[];
    };
    optimization: {
        splitChunks: {
            chunks: string;
            automaticNameDelimiter: string;
        };
        minimizer: import("terser-webpack-plugin")[];
    };
    bail: boolean;
    cache: boolean;
    stats: {
        cached: boolean;
        cachedAssets: boolean;
        chunks: boolean;
        chunkModules: boolean;
        colors: boolean;
        hash: boolean;
        modules: boolean;
        reasons: boolean;
        timings: boolean;
        version: boolean;
    };
};
//# sourceMappingURL=client.base.d.ts.map