"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var shared_1 = require("@dev-scripts/shared");
var fs_1 = require("fs");
var extendFilePath = shared_1.projectDirectory + "/babel.extend.js";
var hasExtendFile = fs_1.existsSync(extendFilePath);
var configureBabelLoader = function (_a) {
    var _b = _a.includedPackages, includedPackages = _b === void 0 ? [] : _b, _c = _a.legacy, legacy = _c === void 0 ? false : _c;
    var options = {
        plugins: [
            '@babel/syntax-dynamic-import',
            '@babel/plugin-proposal-class-properties',
            '@babel/plugin-proposal-object-rest-spread',
        ],
        presets: [
            [
                '@babel/preset-env',
                {
                    targets: legacy ? ['ie 11'] : shared_1.findSupportedBrowsers(),
                    useBuiltIns: false,
                    modules: false,
                    debug: false,
                },
            ],
        ],
        cacheDirectory: shared_1.getDefaultMode() === 'development',
    };
    if (hasExtendFile) {
        options = require(extendFilePath)(options);
    }
    return [
        {
            test: /\.(ts|tsx)?$/,
            exclude: includedPackages,
            use: [
                {
                    loader: 'babel-loader',
                    options: options,
                },
                {
                    loader: 'ts-loader',
                },
            ],
        },
        {
            test: /\.(js|jsx)?$/,
            exclude: includedPackages,
            use: [
                {
                    loader: 'babel-loader',
                    options: options,
                },
            ],
        },
    ];
};
exports.default = configureBabelLoader;
//# sourceMappingURL=javascript-typescript.js.map