"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
var shared_1 = require("@dev-scripts/shared");
var MiniCssExtractPlugin = require("mini-css-extract-plugin");
var isDevelopment = shared_1.getDefaultMode() === 'development';
var cssRegex = /\.(css|scss)$/;
var cssModuleRegex = /\.module\.(css|scss)$/;
var cssClientRegex = /\.client\.(css|scss)$/;
var configureStyleLoader = function (options) {
    if (options === void 0) { options = {}; }
    var defaultOptions = Object.assign({}, {
        isClient: true,
    }, options);
    var cssModulesRules = {
        test: cssModuleRegex,
        use: getStyleLoaders({
            modules: {
                localIdentName: '[local]',
                mode: 'local',
                exportGlobals: true,
                exportOnlyLocals: !defaultOptions.isClient,
            },
        }, defaultOptions.isClient),
    };
    var cssRules = {
        test: cssRegex,
        exclude: [cssModuleRegex, cssClientRegex],
        use: getStyleLoaders({
            modules: false,
        }, defaultOptions.isClient),
    };
    var cssClientRules = {
        test: cssClientRegex,
        use: getStyleLoaders({
            modules: false,
            esModule: false,
        }, false),
    };
    cssClientRules.use.unshift('to-string-loader');
    return [cssModulesRules, cssRules, cssClientRules];
};
function getStyleLoaders(cssLoaderOptions, extract) {
    if (cssLoaderOptions === void 0) { cssLoaderOptions = {}; }
    var sourceMap = isDevelopment;
    var styleLoaders = [
        extract && {
            loader: MiniCssExtractPlugin.loader,
            options: {
                esModule: false,
            },
        },
        {
            loader: 'css-loader',
            options: __assign({ sourceMap: sourceMap, importLoaders: 2 }, cssLoaderOptions),
        },
        {
            loader: 'postcss-loader',
            options: {
                sourceMap: sourceMap,
            },
        },
        {
            loader: 'sass-loader',
            options: {
                sourceMap: sourceMap,
            },
        },
    ].filter(Boolean);
    return styleLoaders;
}
exports.default = configureStyleLoader;
//# sourceMappingURL=style-loader.js.map